import React, { Component } from 'react';
import logo from './logo.svg';
import mqtt from 'mqtt'
import Capteur from './Capteur'

import './App.css';
import {
    Link
} from 'react-router-dom'

import {
    Sensor,
    Datum,
    SensorType,
    fSensorType
} from './class';



class App extends Component {

    constructor(props) {
        super(props);
        this.state = {value: '', capts: [], i:0};

        this.handleChange = this.handleChange.bind(this);
        this.handleSubmit = this.handleSubmit.bind(this);
        this.getCurrentCapteur = this.getCurrentCapteur.bind(this);



    }

    handleChange(event) {
        this.setState({value: event.target.value});
    }

    handleSubmit(event) {
         this.connexion(this.state.value);
        event.preventDefault();
    }

    connexion(url) {

        console.log(url) //127.0.0.1:1234
        url = "127.0.0.1:1234";

        const ws = new WebSocket("ws://" + url);
        ws.onopen = (event) => {
            console.log("We are connected.");
        };

        //MQTT
        var client = mqtt.connect("mqtt://" + url) //'mqtt://127.0.0.1:1234'
        client.subscribe("#");

        const capteurs = [];
        const that = this

        client.on('message', function (topic, message) {

            var objet = JSON.parse(message);
            var name = topic.split("/");
            var datum = new Datum(objet.value);
            var data = new Sensor(this.i, name[1], datum.value);
            var objetfinal = fSensorType(data, objet.type);

           // console.log(capteurs.length);
            if (capteurs.length === 0) {
                objetfinal.tab = [];
                objetfinal.id = this.i;
                capteurs.push(objetfinal);
            } else {
                var j = that.existeElement(objetfinal, capteurs);
                if (j !== -1) {
                    capteurs[j].data = data;
                    // capteurs[j].tab.push(1);
                    if(capteurs[j].tab.length < 5){
                        capteurs[j].tab.push(datum.value);
                    }else{
                        capteurs[j].tab.shift();
                        capteurs[j].tab.push(datum.value);
                    }
                }
                else {
                    objetfinal.tab = [];
                    objetfinal.tab.push(datum.value);
                    objetfinal.id = this.i;
                    capteurs.push(objetfinal);
                }
            }

            that.setState({
                capts: capteurs,
                i: this.i + 1
            });
        })

    }

    existeElement(sensor, capteurs){
        var j;
        var boolean = false;
        for( j=0; j<capteurs.length; j++){
            if(capteurs[j].name === sensor.name){
                return j;
            }
        }
        return -1;
    }

    //TODO : le dernier n'est jamais affiche
    getCurrentCapteur(){
        //console.log(this.state.capts[0]);
       // const obj = this.state.capts[0];

        const p = this.props.location.pathname.substr(1,this.props.location.pathname.length);
       //const p = "MesYeux";
       console.log(p);
        // console.log(this.state.capts);

        //this.state.capts[0].data.data
        //this.state.capts[0].name

        if(this.state.capts[3] !== undefined){
            for(let j=0;j<=3;j++){
                if(this.state.capts[j].name === p){
                    return this.state.capts[j];
                }
            }

          //  console.log("-" + this.state.capts[0].name + "-");
        }
     //  console.log(this.state.capts.indexOf("MesYeux"))

       // return this.state.capts[0];
    }

    render() {
            //console.log(this.state.capts[0])
       /* const route = this.state.capts.map((s) =>
            <Route path="/:Capteur" component={Capteur}/>
        );*/


        const naviguation = this.state.capts.map((s) =>
            <li><Link to={s.name}>
                { s.name}
            </Link></li>
        );



        return (

            <div className="App">
                <header className="App-header">
                    <img src={logo} className="App-logo" alt="logo" />
                    <h1 className="App-title">Welcome to My Sensor</h1>

                </header>

                <form onSubmit={this.handleSubmit}>
                    <label>
                        imput du serveur : <input type="text" value={this.state.value} onChange={this.handleChange} />
                    </label>
                    <input type="submit" value="Submit" />
                </form>




                <div class="wrapper">
                    <article>
                        <div id="route">
                           <Capteur value={this.getCurrentCapteur()}/>
                        </div>
                    </article>


                    <nav>navigation

                            <div id="naviguation">
                                <ul>
                                    {naviguation}
                                </ul>

                            </div>
                    </nav>
                </div>
            </div>

        );
    }
}

export default App;



